Subject: Re: bug#26162: time-duration screws up negative durations

From: Mark H Weaver <[email-masked]>
Date: Sun, 21 Oct 2018 19:31:32 -0400

Zefram <[email-masked]> writes:

> Computing a difference between two SRFI-19 times, using time-difference,
> produces sensible results if the result is positive, but often nonsense
> if it's negative:
>
> scheme@(guile-user)> (use-modules (srfi srfi-19))
> scheme@(guile-user)> (time-difference (make-time time-tai 0 1) (make-time time-tai 1000 0))
> $1 = #<time type: time-duration nanosecond: 999999000 second: 0>
> scheme@(guile-user)> (time-difference (make-time time-tai 1000 0) (make-time time-tai 0 1))
> $2 = #<time type: time-duration nanosecond: 1000001000 second: 0>
>
> The above is computing the same interval both ways round.  The first time
> is correct, but the second is obviously not the negative of the first.

This is fixed by commit 437e1aa03659b77a8eb4b5c6d2b104c03d038564 on the
stable-2.2 branch.  I'm closing this bug now, but feel free to reopen if
appropriate.

> The correct result for the second would be
>
>     #<time type: time-duration nanosecond: 1000 second: -1>
>
> or possibly, at a stretch,
>
>     #<time type: time-duration nanosecond: -999999000 second: 0>

Most of the code in the SRFI-19 reference implementation assumes that
the nanoseconds and seconds fields will have matching signs (if both
non-zero), so I've taken care to use that convention exclusively.

     Thanks,
       Mark